



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>第1章 背景 - Identity Server 4 中文文档(v1.0.0)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">第1章 背景 - Identity Server 4 中文文档(v1.0.0)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-22 09:31:29 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>大多数现代应用程序或多或少看起来像这样：</p>
<div>
<img referrerpolicy="no-referrer"src="https://identityserver4.readthedocs.io/en/latest/_images/appArch.png" />
</div></p>
<p>最常见的互动是：</p>
<ul><li>浏览器与Web应用程序通信</li>
<li>Web应用程序与Web API进行通信（Web应用程序自身 或 代表用户 与 Web API 通信）</li>
<li>基于浏览器的应用程序与Web API通信</li>
<li>本地应用程序与Web API通信</li>
<li>基于服务器的应用程序与Web API通信</li>
<li>Web API与Web API进行通信（WebAPI自身 或 代表用户与另一个WebAPI 通信）</li></ul>
<p>通常，每个层（前端，中间层和后端）都必须保护资源并实现身份验证和授权 - 通常针对同一个用户存储。</p>
<p>将这些基本安全功能外包给安全令牌服务可防止在这些应用程序和端点之间复制该功能。</p>
<p>重构应用程序以支持安全令牌服务会产生以下体系结构和协议：</p>
<div>
<img referrerpolicy="no-referrer"src="https://identityserver4.readthedocs.io/en/latest/_images/protocols.png" />
</div>
<p>这种设计将安全问题分为两部分：</p>
<h2>1.1 认证</h2>
<p>当应用程序需要知道当前用户的身份时，需要进行身份验证。通常，这些应用程序代表该用户管理数据，并且需要确保该用户只能访问允许的数据。最常见的示例是（经典）Web应用程序 - 但是基于本地和JS的应用程序也需要身份验证。</p>
<p>最常见的身份验证协议是SAML2p，WS-Federation和OpenID Connect - SAML2p是最受欢迎和最广泛部署的。</p>
<p>OpenID Connect是三者中的最新产品，但被认为是未来，因为它具有最大的现代应用潜力。它从一开始就为移动应用场景而构建，旨在实现API友好。</p>
<h2>1.2 API访问</h2>
<p>应用程序有两种基本方式与API通信 - 使用应用程序标识或委派用户身份。有时两种方法都需要结合起来。</p>
<p>OAuth2是一种协议，允许应用程序从安全令牌服务请求访问令牌，并使用它们与API通信。此委派降低了客户端应用程序和API的复杂性，因为身份验证和授权可以集中。</p>
<h2>1.3 OpenID Connect和OAuth 2.0 - 更好地结合在一起</h2>
<p>OpenID Connect和OAuth 2.0非常相似 - 事实上，OpenID Connect是OAuth 2.0之上的扩展。两个基本的安全问题，即身份验证和API访问，被合并为一个协议 - 通常只需一次往返安全令牌服务。</p>
<p>我们相信OpenID Connect和OAuth 2.0的结合是在可预见的未来保护现代应用程序的最佳方法。IdentityServer4是这两种协议的实现，经过高度优化，可以解决当今移动，本地和Web应用程序的典型安全问题。</p>
<h2>1.4 IdentityServer4如何提供帮助</h2>
<p>IdentityServer是一个中间件，可将符合规范的OpenID Connect和OAuth 2.0端点添加到任意ASP.NET Core应用程序中。</p>
<p>通常，您构建（或复用）包含登录和注销页面的应用程序（或者 授权确认页），并且IdentityServer 中间件会将需要的协议添加到页面头部，这样一来客户端应用程序就能够使用这些标准协议跟它协商了。</p>
<div>
<img referrerpolicy="no-referrer"src="https://identityserver4.readthedocs.io/en/latest/_images/middleware.png" />
</div>
<p>你可以根据你的需要使用尽可能复杂的宿主应用程序。但是，为了保持受攻击面尽可能小, 我们一般建议你只将认证相关的UI包含进来。</p>
<p><a href="https://github.com/thinksjay/IdentityServer4" rel="external nofollow noreferrer">github地址</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pvw449.html">MySql链接字符串 各种程序连接大合集&lpar;包括asp&period;net&comma;c&num;&comma;等等&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7jpxkq.html">&period;NET Core VS Code 环境配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7w6le9.html">Android studio 自定义打包APK名称</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2r6lw9.html">【读书笔记】读《JavaScript模式》 - 函数复用模式之现代继承模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmeljz9.html">RxJava &plus; Retrofit 的实际应用场景</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdynmk8.html">linux下使用fscanf实现scanf</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wryoxq.html">Ubuntu下Geary安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojnwvxq.html">Altera FPGA中的pin进一步说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zov4pnq.html">ECOS运行环境安装&lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkxg1e8.html">【转】C&plus;&plus;易混知识点3&period; New Operator&comma; Operator New&comma; Placement New 实例分析&comma;比较区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp1vpvq.html">Dapper中条件为In的写法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjyj538.html">【Codeforces 851D Arpa and a list of numbers】</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ov4jg8.html">初试 Kubernetes 集群中使用 Traefik 反向代理</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g25v6q.html">day10-连接mysql虚拟机报错</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw6ed79.html">WebForm - cookie赋值乱码问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ko5x63q.html">ORACLE删除某用户下所有对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emj33k9.html">ccttp图片处理过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jm475g9.html">最大正方形 &amp;&num;183&semi; Maximal Square</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2xy30x9.html">AFN 切换BaseUrl</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pkjmjk8.html">c&sol;c&plus;&plus;内存泄露的检测方法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qwj32338.html">ArcMap AddIn之下载ArcGIS Server地图服务中的数据</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zllx59.html">python语法&lowbar;模块&lowbar;re&lpar;正则表达&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zk67g9.html">使用poi读取Excel文件数据</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdl0vd9.html">C语言面试题分类-&amp;gt&semi;排序算法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpxwnj9.html">nginx&plus;letsencrypt搭建https站点</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zo0mexq.html">老司机带路：《axios从入门到开车  嘀嘀~~》</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1k1gxz9.html">【从零开始搭建自己的&period;NET Core Api框架】（一）创建项目并集成swagger：1&period;1 创建</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jodgx8.html">&lbrack;Swift&rsqb;LeetCode416&period; 分割等和子集 &vert; Partition Equal Subset Sum</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnj71nx8.html">&lbrack;Swift&rsqb;LeetCode968&period;监控二叉树 &vert; Binary Tree Cameras</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv16vpjq.html">微信小程序中样式问题</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
